#ifndef _FILE_H_
#include <vector>
#include <string>
using namespace std;

#include "DiskSpace.h"

class File
{	private:
  	string				name;
  	unsigned long size;
		vector<File>	children;
    bool					is_dir;
    bool					does_exist;
    bool          is_writable;

		void _getDetails();
    void getChildren();
	protected:
  public:
  	File();
    File(string filename, unsigned long filesize);
    File(string filename);
    void copy(char *destination);
    bool isDirectory();
    bool isWriteable();
    bool exists();
    unsigned long getRawFileSize();
    unsigned long getFileSize();
    const char *getFileName();
    unsigned long getDiskSpace(DiskSpace &diskSpace);
    vector<File>::iterator childBegin();
    vector<File>::iterator childEnd();
};

typedef vector<File> FileVector;
#define _FILE_H_
#endif
